Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# PK_Decryptor Class Reference

`#include <cryptlib.h>`

Inheritance diagram for PK_Decryptor:

List of all members.

## Detailed Description

interface for public-key decryptors

Definition at line 1169 of file cryptlib.h.

## Public Member Functions
virtual DecodingResult | Decrypt (RandomNumberGenerator &rng, const byte *ciphertext, unsigned int ciphertextLength, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const =0
| decrypt a byte string, and return the length of plaintext
virtual BufferedTransformation * | CreateDecryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new decryption filter
DecodingResult | FixedLengthDecrypt (RandomNumberGenerator &rng, const byte *ciphertext, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a fixed size ciphertext
virtual unsigned int | MaxPlaintextLength (unsigned int ciphertextLength) const =0
| maximum length of plaintext for a given ciphertext length
virtual unsigned int | CiphertextLength (unsigned int plaintextLength) const =0
| calculate length of ciphertext given length of plaintext
virtual bool | ParameterSupported (const char *name) const =0
| this object supports the use of the parameter with the given name
virtual unsigned int | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0
virtual unsigned int | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual PrivateKey & | AccessPrivateKey ()=0
virtual const PrivateKey & | GetPrivateKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Member Function Documentation

virtual DecodingResult PK_Decryptor::Decrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | ciphertext,
|  | unsigned int | ciphertextLength,
|  | byte * | plaintext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) | const`[pure virtual]`

| decrypt a byte string, and return the length of plaintext Precondition: size of plaintext == MaxPlaintextLength(ciphertextLength) bytes. Returns: the actual length of the plaintext, indication that decryption failed. Implemented in TF_DecryptorBase, DL_DecryptorBase< T >, and DL_DecryptorBase< SCHEME_OPTIONS::Element >. Referenced by PK_DefaultDecryptionFilter::Put2().

BufferedTransformation * PK_Decryptor::CreateDecryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) | const`[virtual]`

| create a new decryption filter Note: caller is responsible for deleting the returned pointer Definition at line 610 of file cryptlib.cpp.

virtual unsigned int PK_CryptoSystem::MaxPlaintextLength | ( | unsigned int | ciphertextLength | ) | const`[pure virtual, inherited]`

| maximum length of plaintext for a given ciphertext length Note: This function returns 0 if ciphertextLength is not valid (too long or too short). Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >. Referenced by PK_DefaultDecryptionFilter::Put2().

virtual unsigned int PK_CryptoSystem::CiphertextLength | ( | unsigned int | plaintextLength | ) | const`[pure virtual, inherited]`

| calculate length of ciphertext given length of plaintext Note: This function returns 0 if plaintextLength is not valid (too long). Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >. Referenced by PK_DefaultEncryptionFilter::Put2().

virtual bool PK_CryptoSystem::ParameterSupported | ( | const char * | name | ) | const`[pure virtual, inherited]`

| this object supports the use of the parameter with the given name some possible parameter names: EncodingParameters, KeyDerivationParameters Implemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

virtual unsigned int PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const`[inline, virtual, inherited]`

| return fixed ciphertext length, if one exists, otherwise return 0 Note: "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length. Reimplemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, and TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >. Definition at line 1129 of file cryptlib.h. Referenced by FixedLengthDecrypt().

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp